namespace UnitTests
{
    /// <summary>
    ///    
    /// </summary>
    public class LowDifficult
    {
        /// <summary>
        ///   CheckMark,   
        /// </summary>
        [Fact]
        public void TestCheckMarkWithCorrectData()
        {
            Assert.True(REG_MARK_LIB.REG_MARK_LIB.CheckMark("a999aa99"));
        }
        /// <summary>
        ///   CheckMark,   
        /// </summary>
        [Fact]
        public void TestCheckMarkWithIncorrectData()
        {
            Assert.False(REG_MARK_LIB.REG_MARK_LIB.CheckMark("a999aa999"));
        }
        /// <summary>
        ///   GetNextMarkAfter,       
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnSecondNumber()
        {
            Assert.Equal("T357OK52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("T356OK52"));
        }
        /// <summary>
        ///   GetNextMarkAfter,        
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnFirstLetter()
        {
            Assert.Equal("Y001OK52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("T999OK52"));
        }
        /// <summary>
        ///   GetNextMarkAfter,        
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnThirdLetter()
        {
            Assert.Equal("A001OM52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("X999OK52"));
        }
        /// <summary>
        ///   GetNextMarkAfter,        
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnSecondLetter()
        {
            Assert.Equal("A001PA52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("X999OX52"));
        }
        /// <summary>
        ///   GetNextMarkAfterInRange,   
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterInRangeWithCorrectData()
        {
            Assert.Equal("A001PA52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999OX52", "A001AA52", "X999XX52"));
        }
        /// <summary>
        ///   GetNextMarkAfterInRange,        ()
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataSmallerThanStart()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("A001AA52", "X999OX52", "X999XX52"));
        }
        /// <summary>
        ///   GetNextMarkAfterInRange,        ()
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataBiggerThanEnd()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999YX52", "A001AA52", "X999OX52"));
        }
        /// <summary>
        ///   GetNextMarkAfterInRange,   
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataIncorrectBounds()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999YX52", "X999OX52", "A001AA52"));
        }
        /// <summary>
        ///   GetCombinationsCountInRange,   
        /// </summary>
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectData()
        {
            Assert.Equal(2, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("T356OK52", "T357OK52"));
        }
        /// <summary>
        ///   GetCombinationsCountInRange,   
        /// </summary>
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectDataReverse()
        {
            Assert.Equal(2, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("T357OK52", "T356OK52"));
        }
        /// <summary>
        ///   GetCombinationsCountInRange,   
        /// </summary>
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectDataEqualsBounds()
        {
            Assert.Equal(1, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("T356OK52", "T356OK52"));
        }
    }

    /// <summary>
    ///    
    /// </summary>
    public class HighDifficult
    {
        /// <summary>
        ///   CheckMark,   null
        /// </summary>
        [Fact]
        public void TestCheckMarkOnNull()
        {
            Assert.Throws<ArgumentNullException>(() => REG_MARK_LIB.REG_MARK_LIB.CheckMark(null));
        }

        /// <summary>
        ///   GetNextMarkAfter,    
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("Hello world!"));
        }

        /// <summary>
        ///   GetNextMarkAfter,   ,     
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterOnNotNextMark()
        {
            Assert.Throws<Exception>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("x999xx52"));
        }

        /// <summary>
        ///   GetNextMarkAfterInRange,    
        /// </summary>
        [Fact]
        public void TestGetNextMarkAfterInRangeOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("Hello world!", "a999aa52", "a999aa52"));
        }

        /// <summary>
        ///   GetCombinationsCountInRange,    
        /// </summary>
        [Fact]
        public void TestGetCombinationsCountInRangeOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("Hello world!", "a999aa52"));
        }
    }
}